; Channels toolkit v1.00.				    2006 Marcel Kilgus

	section ch_ext

	xref	ut_chan1
	xref	ut_rtfd1
	xref	ut_gxli1
	xref	ut_gxlin
	xref	ut_gtlin
	xref	ut_gxst1
	xref	ut_retst
	xref	ut_rtint
	xref	ut_chkri

	include 'dev8_keys_sys'
	include 'dev8_keys_qlv'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_hdr'
	include 'dev8_keys_err'
	include 'dev8_mac_proc'

;+++
; Initialise SBASIC procedures
;---
ch_initp
	lea	ch_procs,a1
	move.w	sb.inipr,a2
	jmp	(a2)

ch_procs
	proc_stt
	proc_ref IOB_FLIN
	proc_ref IOB_FMUL
	proc_end
	proc_stt
	proc_ref CHAN_BASE
	proc_ref IOF_POSA
	proc_ref IOF_POSR
	proc_ref IOF_RHDR
	proc_ref IOF_SHDR
	proc_end

;+++
; base = CHAN_BASE
;---
chan_base
	jsr	ut_chan1
	bne.s	ch_rts

	move.l	a0,d7
	moveq	#0,d0
	trap	#1
	move.l	sys_chtb(a0),a0 	; base of channel list
	lsl.w	#2,d7
	move.l	(a0,d7.w),d1		; ptr to CDB
	jmp	ut_rtfd1

ch_ipar
	moveq	#err.ipar,d0
ch_rts
	rts

;+++
; pos = IOF_POSA #ch,pos
;---
iof_posa
	moveq	#iof.posa,d7
	bra.s	iof_pos

;+++
; pos = IOF_POSR #ch,relpos
;---
iof_posr
	moveq	#iof.posr,d7
iof_pos
	jsr	ut_chan1
	bne.s	ch_rts
	jsr	ut_gxli1
	bne.s	ch_rts
	move.l	(a6,a1.l),d1
	addq.l	#4,sb_arthp(a6) 	; reset ri stack

	move.l	d7,d0
	moveq	#-1,d3
	trap	#3
	move.l	d0,d1
	jmp	ut_rtfd1

;+++
; h$ = IOF_RHDR(#ch)
;---
iof_rhdr
	jsr	ut_chan1
	bne.s	ch_rts

	moveq	#hdr.len,d2
	sub.l	d2,sp			; reserve some space
	moveq	#iof.rhdr,d0
	moveq	#-1,d3
	move.l	sp,a1
	trap	#3			; read header of file
	tst.l	d0
	bne.s	rhdr_rts

	move.l	sb_arthp(a6),a1
	andi.l	#$ffff,d1
	move.l	d1,d2			; remember bytes read
	addq.w	#3,d1			; rounding up and space for length
	bclr	#0,d1
	jsr	ut_chkri		; allocate space on RI stack
	sub.l	d1,a1			; beginning of RI space
	move.l	a1,a2
	move.w	d2,(a6,a2.l)		; original length
	addq.w	#2,a2
	beq.s	rhdr_rts
	move.l	sp,a3
rhdr_loop
	move.b	(a3)+,(a6,a2.l)
	addq.w	#1,a2
	subq.w	#1,d2
	bne.s	rhdr_loop
	add.w	#hdr.len,sp
	jmp	ut_retst		; return string

rhdr_rts
	add.w	#hdr.len,sp
	rts

;+++
; length_set = IOF_SHDR(#ch, h$)
;---
iof_shdr
	jsr	ut_chan1
	bne.s	ch_rts

	jsr	ut_gxst1		; get single string
	bne	ch_rts

	addq.w	#2,a1
	moveq	#iof.shdr,d0
	moveq	#-1,d3
	trap	#4
	trap	#3
	tst.l	d0
	bne	ch_rts
	subq.w	#2,a1

	move.w	(a6,a1.l),d2
	addq.w	#3,d2
	bclr	#0,d2
	add.w	d2,a1
	move.l	a1,sb_arthp(a6) 	; reset ri stack
	jmp	ut_rtint

;+++
; IOB_FLIN(#ch, s$(, timeout))
;---
iob_flin
	moveq	#iob.flin,d7
	move.l	#$7fff,d6		; always max string length
	bra.s	iob_do

;+++
; IOB_FMUL(#ch, s$, length(, timeout))
;---
iob_fmul
	moveq	#iob.fmul,d7
	moveq	#0,d6			; get length from parameter
iob_do
	move.l	d6,-(sp)
	jsr	ut_chan1
	movem.l (sp)+,d6
	bne	ch_rts
	move.l	a0,a4

	move.l	a5,d0
	sub.l	a3,d0
	subq.l	#8,d0
	bcs	ch_ipar 		; need at least 1!

	addq.l	#8,a3
	jsr	ut_gtlin
	move.l	sb_arthp(a6),a1 	; might not be set if d3=0!
	move.w	d3,d0
	moveq	#-1,d3			; default timeout
	tst.l	d6			; need length parameter?
	bne.s	iob_timeout		; ...no, already set
	subq.w	#1,d0
	bcs	ch_ipar 		; ...no length there
	move.l	(a6,a1.l),d6		; get length
	addq.l	#4,a1
iob_timeout
	tst.w	d0
	beq.s	iob_notimeout
	move.l	(a6,a1.l),d3		; optional timeout
	addq.l	#4,a1
iob_notimeout
	move.l	a1,sb_arthp(a6)
	subq.l	#8,a3			; return to 1st parameter

iob_chkpar
	move.b	#%10001111,d0
	and.b	1(a6,a3.l),d0
	cmpi.b	#%00000001,d0		; string parameter?
	bne	ch_ipar 		; ...no, too bad

	move.l	d6,d1
	addq.l	#3,d1
	bclr	#0,d1			; reserve enough space on stack
	jsr	ut_chkri
	move.l	a1,a5
	sub.l	d1,a1
	move.l	a1,sb_arthp(a6)

	move.l	d6,d1			; size to fetch
	move.w	d1,(a6,a1.l)
	move.w	d1,d2
	addq.l	#2,a1
	move.l	d7,d0			; operation
	move.l	a4,a0			; channel ID
	trap	#4
	trap	#3
	cmpi.l	#err.bffl,d0
	beq.s	iob_bffl
	tst.l	d0
	bne	ch_rts

iob_bffl
	move.l	d0,d5
	move.l	sb_arthp(a6),a1
	move.w	d1,(a6,a1.l)		; put in real length
	move.w	sb.putp,a2
	jsr	(a2)			; put parameter value
	tst.l	d0
	bne	ch_rts

	move.l	a5,sb_arthp(a6) 	; restore stack
	move.l	d5,d0			; restore ok/error
	rts

	end
